Index: trunk/kernel/libk/remote_fifo.h
===================================================================
--- trunk/kernel/libk/remote_fifo.h	(revision 690)
+++ trunk/kernel/libk/remote_fifo.h	(revision 1)
@@ -1,7 +1,6 @@
 /*
- * remote_fifo.h - Lock-less Single-Reader Multiple-Writers FIFO
+ * remote_fifo.h - kernel generic SRMW FIFO
  *
- * Authors : Mohamed Lamine Karaoui (2015)
- *           Alain Greiner (2016,2017)
+ * Authors : Mohamed Lamine Karaoui / Alain Greiner (2016)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -26,33 +25,29 @@
 #define _REMOTE_FIFO_H_
 
-#include <kernel_config.h>
-#include <hal_kernel_types.h>
-#include <printk.h>
+#include <almos_config.h>
+#include <hal_types.h>
 #include <errno.h>
 #include <hal_remote.h>
 
 /************************************************************************************
- * This structure defines a generic, single reader, multiple writers FIFO,
- * that is used for - RPC based - inter cluster communications.
- * Each FIF0 slot can contain one 64 bits integer (or one extended pointer).
- * The number of slots is defined by the CONFIG_RPC_FIFO_SLOTS parameter.
- * - The write accesses are implemented using a lock-free algorithm, as it uses
- *   a ticket based mechanism to handle concurrent access between multiple writers.
- *   In case of FIFO full, the writer deschedule without blocking, to retry later.
- * - The reader must take the try_lock implemented by the "owner" field, using
- *   an atomic_add(). The TRDID is a good owner identifier, because all
- *   RPC threads in a given cluster belong to the same kernel process,
- *   and RPC threads cannot have local index LTID = 0.
-*
- * WARNING : Each FIFO requires 12 + (12 * CONFIG_RPC_FIFO_SLOTS) bytes.
+ * This structure defines a generic, single reader, multiple writers
+ * remote FIFO, that is used by the RPCs for inter cluster communications.
+ * The accesses are implemented using a lock-free algorithm, as it
+ * uses a ticket based mechanism to handle concurrent access between
+ * the multiple writers.
+ * Each FIF0 slot can contain one full cache line, even if RPCs store only
+ * an extended pointer on the RPC descriptor in each slot.
+ * In case of FIFO full, the writer deschedule without blocking, to retry later.
+ *
+ * WARNING : the number of slots is statically defined by the global 
+ * configuration parameter CONFIG_REMOTE_FIFO_SLOTS for all fifos, requiring
+ * CACHE_LINE_SIZE * CONFIG_REMOTE_FIFO_SLOTS bytes for each FIFO...
  ***********************************************************************************/
-
 typedef struct remote_fifo_s
 {
-    uint32_t           owner;                            /*! owner thread trdid    */
 	volatile uint32_t  wr_id;                            /*! write slot index      */
 	volatile uint32_t  rd_id;                            /*! read  slot index      */
-    volatile uint32_t  valid[CONFIG_RPC_FIFO_SLOTS];  /*! empty slot if 0       */
-	uint64_t           data[CONFIG_RPC_FIFO_SLOTS];   /*! fifo slot content     */
+    volatile bool_t    valid[CONFIG_REMOTE_FIFO_SLOTS];  /*! empty slot if false   */
+	cacheline_t        data[CONFIG_REMOTE_FIFO_SLOTS];   /*! fifo slot content     */
 }
 remote_fifo_t;
@@ -62,47 +57,53 @@
  * It can only initialise a local FIFO.
  ************************************************************************************
- * @ fifo    : local pointer to the local fifo.
+ * @ fifo    : pointer to the local fifo.
  ***********************************************************************************/
-void remote_fifo_init( remote_fifo_t * fifo );
+void local_fifo_init( remote_fifo_t * fifo );
 
 /************************************************************************************
  * This non blocking function tries to get one item from the local fifo.
- * The reader must get exclusive access for read before calling this function.  
+ * The reader must get exclusive access before calling this function.  
  * The read slot index is incremented.
  ************************************************************************************
- * @ fifo    : local pointer to the local fifo.
- * @ item    : [out] pointer on buffer for extracted item.
+ * @ fifo    : pointer to the local fifo.
+ * @ item    : pointer on destination buffer for extracted item.
+ * @ size    : actual number of bytes in one item.
  * @ return  0 on success, EAGAIN if the buffer is empty.
  ***********************************************************************************/
-error_t remote_fifo_get_item( remote_fifo_t * fifo, 
-                              uint64_t      * item );
+error_t local_fifo_get_item( remote_fifo_t * fifo, 
+                             void          * item,
+                             uint32_t        size );
 
 /************************************************************************************
  * This blocking function puts one item to a remote fifo identified
- * by an extended pointer. It gets a write ticket on the slot to be written,
- * using a remote_atomic_add() on the write slot index. Then, it waits until
- * the slot is empty, using a descheduling policy without blocking if required. 
- * It implements a watchdog, returning when the item has been successfully
- * registered, or after CONFIG_RPC_FIFO_MAX_ITERATIONS failures.   
+ * by an extended pointer.
+ * This function gets a write ticket using a remote_atomic_increment on the
+ * write slot index and waits until the slot is empty, using a descheduling
+ * policy (without blocking).
  ************************************************************************************
- * @ fifo    : extended pointer to the remote fifo.
- * @ item    : item to be stored.
+ * @ fifo    : extended pointer to the fifo in remote cluster.
+ * @ item    : pointer on a local buffer containing the item to be stored.
+ * @ size    : actual number of bytes in one item.
+ * @ first   : return value (true if first item registered in remote fifo)
  * @ return  0 on success / EBUSY if a contention has been detected.
  ***********************************************************************************/
 error_t remote_fifo_put_item( xptr_t     fifo,
-                              uint64_t   item );
+                              void     * item,
+                              uint32_t   size,
+                              bool_t   * first );
 
 /************************************************************************************
  * Query if local fifo is empty
  ************************************************************************************
- * @ fifo    : local pointer to the local fifo.
+ * @ fifo    : pointer to the fifo.
  * @ return true if the fifo is empty, false otherwise.
  ***********************************************************************************/
-bool_t remote_fifo_is_empty( remote_fifo_t * fifo );
+bool_t local_fifo_is_empty( remote_fifo_t * fifo );
 
 /************************************************************************************
  * Query if remote fifo is full
  ************************************************************************************
- * @ fifo    : extended pointer to the remote fifo.
+ * @ fifo    : pointer to the fifo in remote cluster.
+ * @ cxy	 : remote cluster index.
  * @ return true if the fifo is full, false otherwise.
  ***********************************************************************************/
@@ -112,5 +113,6 @@
  * Query number ot items in remote fifo.
  ************************************************************************************
- * @ fifo     : extended pointer to the remote fifo.
+ * @ fifo     : pointer to the fifo in remote cluster.
+ * @ cxy	  : remote cluster index.
  * @ return  number of items.
  ***********************************************************************************/
Index: trunk/kernel/libk/remote_rwlock.c
===================================================================
--- trunk/kernel/libk/remote_rwlock.c	(revision 690)
+++ trunk/kernel/libk/remote_rwlock.c	(revision 1)
@@ -1,6 +1,7 @@
 /*
- * remote_rwlock.c - kernel remote read/write lock implementation.
+ * remote_rwlock.c - kernel remote rwlock implementation.
  * 
- * Authors    Alain   Greiner (2016,2017,2018,2019)
+ * Authors  Mohamed Karaoui (2015)
+ *          Alain   Greiner (2016)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -22,432 +23,183 @@
  */
 
-#include <hal_kernel_types.h>
+#include <hal_types.h>
 #include <hal_remote.h>
 #include <hal_irqmask.h>
 #include <thread.h>
-#include <printk.h>
 #include <cluster.h>
 #include <scheduler.h>
 #include <remote_rwlock.h>
 
-//////////////////////////////////////////////////////////////////////////////
-//                Extern global variables
-//////////////////////////////////////////////////////////////////////////////
-
-extern char * lock_type_str[];          // allocated in kernel_init.c
-
-
-//////////////////////////////////////////
-void remote_rwlock_init( xptr_t   lock_xp,
-                         uint32_t type )
+///////////////////////////////////////////
+void remote_rwlock_init( xptr_t lock_xp )
 { 
-    remote_rwlock_t * lock_ptr = GET_PTR( lock_xp );
-    cxy_t             lock_cxy = GET_CXY( lock_xp );
-
-    hal_remote_s32 ( XPTR( lock_cxy , &lock_ptr->taken ) , 0 );
-    hal_remote_s32 ( XPTR( lock_cxy , &lock_ptr->count ) , 0 );
-
-    xlist_root_init( XPTR( lock_cxy , &lock_ptr->rd_xroot ) );
-    xlist_root_init( XPTR( lock_cxy , &lock_ptr->wr_xroot ) );
-
-    remote_busylock_init( XPTR( lock_cxy , &lock_ptr->lock ) , type ); 
-
-#if DEBUG_RWLOCK_TYPE
-thread_t * this = CURRENT_THREAD;
-bool_t     cond = (type == DEBUG_RWLOCK_TYPE) &&
-                  (((lock_cxy == (cxt_t)DEBUG_RWLOCK_CXY) &&
-                    (lock_ptr == (remote_queuelock_t*)DEBUG_RWLOCK_PTR)) ||
-                   ((DEBUG_RWLOCK_CXY == 0) &&
-                    (DEBUG_RWLOCK_PTR == 0)));
-if( cond )
-printk("\n[%s] thread[%x,%x] initialise lock %s [%x,%x]\n",
-__FUNCTION__, this->process->pid, this->trdid,
-lock_type_str[type], local_cxy, lock_ptr );
-#endif
-
+    remote_rwlock_t * lock_ptr = (remote_rwlock_t *)GET_PTR( lock_xp );
+    cxy_t             lock_cxy = GET_CXY( lock_xp );
+
+    hal_remote_sw ( XPTR( lock_cxy , &lock_ptr->ticket )  , 0 );
+    hal_remote_sw ( XPTR( lock_cxy , &lock_ptr->current ) , 0 );
+    hal_remote_sw ( XPTR( lock_cxy , &lock_ptr->count )   , 0 );
+    hal_remote_swd( XPTR( lock_cxy , &lock_ptr->owner )   , XPTR_NULL );
 }
 
-///////////////////////////////////////////////
-void remote_rwlock_rd_acquire( xptr_t lock_xp )
+//////////////////////////////////////////////
+void remote_rwlock_rd_lock( xptr_t lock_xp )
 { 
-    thread_t * this = CURRENT_THREAD;
-
-    // check calling thread can yield
-    thread_assert_can_yield( this , __FUNCTION__ );
-
-    // get cluster and local pointer on remote_rwlock
-    remote_rwlock_t * lock_ptr = GET_PTR( lock_xp );
-    cxy_t             lock_cxy = GET_CXY( lock_xp );
-
-#if DEBUG_RWLOCK_TYPE
-uint32_t lock_type   = hal_remote_l32( XPTR( lock_cxy , &lock_ptr->lock.type ) );
-bool_t   cond        = (type == DEBUG_RWLOCK_TYPE) &&
-                       (((lock_cxy == (cxt_t)DEBUG_RWLOCK_CXY) &&
-                         (lock_ptr == (remote_queuelock_t*)DEBUG_RWLOCK_PTR)) ||
-                        ((DEBUG_RWLOCK_CXY == 0) &&
-                         (DEBUG_RWLOCK_PTR == 0)));
-xptr_t   wr_root_xp  = XPTR( lock_cxy , &lock_ptr->wr_xroot );
-#endif
-
-    // build useful extended pointers
-    xptr_t busylock_xp = XPTR( lock_cxy , &lock_ptr->lock );
-    xptr_t taken_xp    = XPTR( lock_cxy , &lock_ptr->taken );
-    xptr_t count_xp    = XPTR( lock_cxy , &lock_ptr->count );
-    xptr_t rd_root_xp  = XPTR( lock_cxy , &lock_ptr->rd_xroot );
-
-    // get busylock
-    remote_busylock_acquire( busylock_xp );
-
-    // block and deschedule if lock taken
-    while( hal_remote_l32( taken_xp ) )
+	uint32_t   mode;
+    uint32_t   ticket;
+
+    // get cluster and local pointer on remote_rwlock
+    remote_rwlock_t * lock_ptr = (remote_rwlock_t *)GET_PTR( lock_xp );
+    cxy_t             lock_cxy = GET_CXY( lock_xp );
+
+    // get cluster and local pointer on local thread
+    cxy_t               thread_cxy = local_cxy;
+    thread_t          * thread_ptr = CURRENT_THREAD;
+
+    // extended pointers on ticket, current, count, and thread->remote_locks
+    xptr_t              ticket_xp  = XPTR( lock_cxy   , &lock_ptr->ticket );
+    xptr_t              current_xp = XPTR( lock_cxy   , &lock_ptr->current );
+    xptr_t              count_xp   = XPTR( lock_cxy   , &lock_ptr->count );
+    xptr_t              locks_xp   = XPTR( thread_cxy , &thread_ptr->remote_locks );
+
+    // disable interrupts
+    hal_disable_irq( &mode );
+
+    // get next free ticket
+    ticket = hal_remote_lw( ticket_xp );
+
+    // loop to take the lock 
+	while( ticket != hal_remote_lw( current_xp ) )
+	{
+        hal_fixed_delay( CONFIG_RWLOCK_DELAY );
+	}
+
+    ////////// From here we have the lock  ////////////
+
+    // increment count and thead.remote_locks
+    hal_remote_atomic_add( count_xp , 1 );
+    hal_remote_atomic_add( locks_xp , 1 );
+
+    // sync
+    hal_wbflush();
+
+    // release lock to allow several simultaneous readers
+    hal_remote_atomic_add( current_xp , 1 );
+
+    // enable interrupts
+	hal_restore_irq( mode );
+
+}  // end remote_rwlock_rd_lock()
+
+////////////////////////////////////////////////
+void remote_rwlock_rd_unlock( xptr_t lock_xp )
+{
+	uint32_t            mode;
+
+    // get cluster and local pointer on remote_rwlock
+    remote_rwlock_t * lock_ptr = (remote_rwlock_t *)GET_PTR( lock_xp );
+    cxy_t             lock_cxy = GET_CXY( lock_xp );
+
+    // get cluster and local pointer on local thread
+    cxy_t               thread_cxy = local_cxy;
+    thread_t          * thread_ptr = CURRENT_THREAD;
+
+    // extended pointers on lock->count and thread->remote_locks
+    xptr_t              count_xp = XPTR( lock_cxy   , &lock_ptr->count );
+    xptr_t              locks_xp = XPTR( thread_cxy , &thread_ptr->remote_locks );
+
+    // disable interrupts
+	hal_disable_irq( &mode );
+  
+    // decrement count and thread.remote_locks
+    hal_remote_atomic_add( count_xp , -1 );
+	hal_remote_atomic_add( locks_xp , -1 );
+
+    // enable interrupts
+	hal_restore_irq( mode );
+
+}  // end remote_rwlock_rd_unlock()
+
+//////////////////////////////////////////////
+void remote_rwlock_wr_lock( xptr_t lock_xp )
+{ 
+	uint32_t   mode;
+    uint32_t   ticket;
+
+    // get cluster and local pointer on remote_rwlock
+    remote_rwlock_t * lock_ptr = (remote_rwlock_t *)GET_PTR( lock_xp );
+    cxy_t             lock_cxy = GET_CXY( lock_xp );
+
+    // get cluster and local pointer on local thread
+    cxy_t               thread_cxy = local_cxy;
+    thread_t          * thread_ptr = CURRENT_THREAD;
+
+    // compute extended pointers on lock->ticket, lock->owner, and thread->remote_locks
+    xptr_t              ticket_xp  = XPTR( lock_cxy   , &lock_ptr->ticket );
+    xptr_t              count_xp   = XPTR( lock_cxy   , &lock_ptr->count );
+    xptr_t              current_xp = XPTR( lock_cxy   , &lock_ptr->current );
+    xptr_t              owner_xp   = XPTR( lock_cxy   , &lock_ptr->owner );
+    xptr_t              locks_xp   = XPTR( thread_cxy , &thread_ptr->remote_locks );
+    xptr_t              thread_xp  = XPTR( thread_cxy , thread_ptr );
+
+    // disable interrupts
+    hal_disable_irq( &mode );
+
+    // get next free ticket
+    ticket = hal_remote_lw( ticket_xp );
+
+    // loop to take the lock 
+	while( ticket != hal_remote_lw( current_xp ) )
+	{
+        hal_fixed_delay( CONFIG_RWLOCK_DELAY );
+	}
+
+    ////////// From here we have the lock  ////////////
+
+    // wait completion of read accesses
+    while( hal_remote_lw( count_xp ) != 0 )
     {
-
-#if DEBUG_RWLOCK_TYPE
-if( cond )
-printk("\n[%s] thread[%x,%x] READ BLOCK on %s [%x,%x]\n"
-"     taken %d / count %d / wr_empty %d / rd_empty %d\n",
-__FUNCTION__, this->process->pid, this->trdid, 
-lock_type_str[lock_type], lock_cxy, lock_ptr,
-hal_remote_l32( taken_xp ), hal_remote_l32( count_xp ),
-xlist_is_empty( wr_root_xp ), xlist_is_empty( rd_root_xp ) );
-#endif
-        // get pointer on calling thread
-        thread_t * this = CURRENT_THREAD;
-
-        // register reader thread in waiting queue
-        xlist_add_last( rd_root_xp , XPTR( local_cxy , &this->wait_xlist ) );
-
-        // block reader thread
-        thread_block( XPTR( local_cxy , this ) , THREAD_BLOCKED_LOCK );
-
-        // release busylock
-        remote_busylock_release( busylock_xp );
-
-        // deschedule
-        sched_yield("reader wait remote_rwlock");
-
-        // get busylock
-        remote_busylock_acquire( busylock_xp );
+        hal_fixed_delay( CONFIG_RWLOCK_DELAY );
     }
 
-    // increment number of readers
-    hal_remote_atomic_add( count_xp , 1 );
-
-    hal_fence();
-
-#if DEBUG_RWLOCK_TYPE
-if( cond )
-printk("\n[%s] thread[%x,%x] READ ACQUIRE %s [%x,%x]\n"
-"     taken %d / count %d / wr_empty %d / rd_empty %d\n",
-__FUNCTION__, this->process->pid, this->trdid,
-lock_type_str[lock_type], lock_cxy, lock_ptr,
-hal_remote_l32( taken_xp ), hal_remote_l32( count_xp ),
-xlist_is_empty( wr_root_xp ), xlist_is_empty( rd_root_xp ) );
-#endif
-
-    // release busylock
-    remote_busylock_release( busylock_xp );
-
-}  // end remote_rwlock_rd_acquire()
-
-///////////////////////////////////////////////
-void remote_rwlock_wr_acquire( xptr_t lock_xp )
-{ 
-    thread_t * this = CURRENT_THREAD;
-
-    // check calling thread can yield
-    thread_assert_can_yield( this , __FUNCTION__ );
-
-    // get cluster and local pointer on remote_rwlock
-    remote_rwlock_t * lock_ptr = GET_PTR( lock_xp );
-    cxy_t             lock_cxy = GET_CXY( lock_xp );
-
-#if DEBUG_RWLOCK_TYPE
-uint32_t lock_type   = hal_remote_l32( XPTR( lock_cxy , &lock_ptr->lock.type ) );
-bool_t   cond        = (type == DEBUG_RWLOCK_TYPE) &&
-                       (((lock_cxy == (cxt_t)DEBUG_RWLOCK_CXY) &&
-                         (lock_ptr == (remote_queuelock_t*)DEBUG_RWLOCK_PTR)) ||
-                        ((DEBUG_RWLOCK_CXY == 0) &&
-                         (DEBUG_RWLOCK_PTR == 0)));
-xptr_t   rd_root_xp  = XPTR( lock_cxy , &lock_ptr->rd_xroot );
-#endif
-
-    // build useful extended pointers
-    xptr_t busylock_xp = XPTR( lock_cxy , &lock_ptr->lock );
-    xptr_t taken_xp    = XPTR( lock_cxy , &lock_ptr->taken );
-    xptr_t count_xp    = XPTR( lock_cxy , &lock_ptr->count );
-    xptr_t wr_root_xp  = XPTR( lock_cxy , &lock_ptr->wr_xroot );
-
-    // get busylock
-    remote_busylock_acquire( busylock_xp );
-
-    // block and deschedule if lock already taken or current readers
-    while( hal_remote_l32( taken_xp ) || hal_remote_l32( count_xp ) )
-    {
-
-#if DEBUG_RWLOCK_TYPE
-if( cond )
-printk("\n[%s] thread[%x,%x] WRITE BLOCK on %s [%x,%x]\n"
-"     taken %d / count %d / wr_empty %d / rd_empty %d\n",
-__FUNCTION__, this->process->pid, this->trdid, 
-lock_type_str[lock_type], lock_cxy, lock_ptr, 
-hal_remote_l32( taken_xp ), hal_remote_l32( count_xp ),
-xlist_is_empty( wr_root_xp ), xlist_is_empty( rd_root_xp ) );
-#endif
-
-        // get local pointer on calling thread
-        thread_t * this = CURRENT_THREAD;
-
-        // register writer thread in waiting queue
-        xlist_add_last( wr_root_xp , XPTR( local_cxy , &this->wait_xlist ) );
-
-        // block writer thread
-        thread_block( XPTR( local_cxy , this ) , THREAD_BLOCKED_LOCK );
-
-        // release busylock
-        remote_busylock_release( busylock_xp );
-
-        // deschedule
-        sched_yield("writer wait remote_rwlock");
-
-        // get busylock
-        remote_busylock_acquire( busylock_xp );
-    }
-
-    // take rwlock for write
-    hal_remote_s32( taken_xp , 1 );
-
-#if DEBUG_RWLOCK_TYPE
-if( cond )
-printk("\n[%s] thread[%x,%x] WRITE ACQUIRE %s [%x,%x]\n"
-"     taken %d / count %d / wr_empty %d / rd_empty %d\n",
-__FUNCTION__, this->process->pid, this->trdid, 
-lock_type_str[lock_type], lock_cxy, lock_ptr,
-hal_remote_l32( taken_xp ), hal_remote_l32( count_xp ),
-xlist_is_empty( wr_root_xp ), xlist_is_empty( rd_root_xp ) );
-#endif
-
-    // release busylock
-    remote_busylock_release( busylock_xp );
-
-}  // end remote_rwlock_wr_acquire()
-
-
-///////////////////////////////////////////////
-void remote_rwlock_rd_release( xptr_t lock_xp )
+    // register owner thread and increment thread.remote_locks
+    hal_remote_swd( owner_xp , thread_xp );
+    hal_remote_atomic_add( locks_xp , 1 );
+
+    // enable interrupts
+	hal_restore_irq( mode );
+
+}  // end remote_rwlock_wr_lock()
+
+//////////////////////////////////////////////
+void remote_rwlock_wr_unlock( xptr_t lock_xp )
 {
-    // memory barrier before lock release
-    hal_fence();
-
-    // get cluster and local pointer on remote_rwlock
-    remote_rwlock_t * lock_ptr = GET_PTR( lock_xp );
-    cxy_t             lock_cxy = GET_CXY( lock_xp );
-
-    // build useful extended pointers
-    xptr_t busylock_xp = XPTR( lock_cxy , &lock_ptr->lock );
-    xptr_t count_xp    = XPTR( lock_cxy , &lock_ptr->count );
-    xptr_t rd_root_xp  = XPTR( lock_cxy , &lock_ptr->rd_xroot );
-    xptr_t wr_root_xp  = XPTR( lock_cxy , &lock_ptr->wr_xroot );
-
-    // get busylock
-    remote_busylock_acquire( busylock_xp );
-
-	// decrement number of readers
-    hal_remote_atomic_add( count_xp , -1 );
-
-#if DEBUG_RWLOCK_TYPE
-thread_t * this      = CURRENT_THREAD;
-uint32_t   lock_type = hal_remote_l32( XPTR( lock_cxy , &lock_ptr->lock.type ) );
-bool_t     cond      = (type == DEBUG_RWLOCK_TYPE) &&
-                       (((lock_cxy == (cxt_t)DEBUG_RWLOCK_CXY) &&
-                         (lock_ptr == (remote_queuelock_t*)DEBUG_RWLOCK_PTR)) ||
-                        ((DEBUG_RWLOCK_CXY == 0) &&
-                         (DEBUG_RWLOCK_PTR == 0)));
-xptr_t     taken_xp  = XPTR( lock_cxy , &lock_ptr->taken );
-#endif
-
-#if DEBUG_RWLOCK_TYPE
-if( cond )
-printk("\n[%s] thread[%x,%x] READ RELEASE %s [%x,%x]\n"
-"     taken %d / count %d / wr_empty %d / rd_empty %d\n",
-__FUNCTION__, this->process->pid, this->trdid,
-lock_type_str[lock_type], lock_cxy, lock_ptr,
-hal_remote_l32( taken_xp ), hal_remote_l32( count_xp ),
-xlist_is_empty( wr_root_xp ), xlist_is_empty( rd_root_xp ) );
-#endif
-
-    // release first writer in waiting queue if no current readers
-    // and writers waiting queue non empty
-    if( (hal_remote_l32( count_xp ) == 0) && (xlist_is_empty( wr_root_xp ) == false) )
-    {
-        // get first writer thread
-        xptr_t      thread_xp  = XLIST_FIRST( wr_root_xp , thread_t, wait_xlist );
-        cxy_t       thread_cxy = GET_CXY( thread_xp ); 
-        thread_t *  thread_ptr = GET_PTR( thread_xp ); 
-
-        // remove this waiting thread from waiting list
-        xlist_unlink( XPTR( thread_cxy , &thread_ptr->wait_xlist ) );
-
-        // unblock this waiting thread
-        thread_unblock( thread_xp , THREAD_BLOCKED_LOCK );
-
-#if DEBUG_RWLOCK_TYPE
-if( cond )
-{
-    trdid_t     trdid     = hal_remote_l32( XPTR( thread_cxy , &thread_ptr->trdid ) );
-    process_t * process   = hal_remote_lpt( XPTR( thread_cxy , &thread_ptr->process ) );
-    uint32_t    pid       = hal_remote_l32( XPTR( thread_cxy , &process->pid ) );
-    printk("\n[%s] thread[%x,%x] UNBLOCK thread[%x,%x] / rwlock %s [%x,%x]\n",
-    __FUNCTION__, this->process->pid, this->trdid, pid, trdid, 
-    lock_type_str[lock_type], lock_cxy, lock_ptr );
-}
-#endif
-
-    }
-
-    // release all readers in waiting queue if writers waiting queue empty
-    // and readers waiting queue non empty
-    else if( xlist_is_empty( wr_root_xp ) && (xlist_is_empty( rd_root_xp ) == false) )
-    {
-        while( xlist_is_empty( rd_root_xp ) == false )
-        {
-            // get first writer thread
-            xptr_t      thread_xp  = XLIST_FIRST( wr_root_xp , thread_t, wait_xlist );
-            cxy_t       thread_cxy = GET_CXY( thread_xp ); 
-            thread_t *  thread_ptr = GET_PTR( thread_xp ); 
-
-            // remove this waiting thread from waiting list
-            xlist_unlink( XPTR( thread_cxy , &thread_ptr->wait_xlist ) );
-
-            // unblock this waiting thread
-            thread_unblock( thread_xp , THREAD_BLOCKED_LOCK );
-
-#if DEBUG_RWLOCK_TYPE
-if( cond )
-{
-    trdid_t     trdid     = hal_remote_l32( XPTR( thread_cxy , &thread_ptr->trdid ) );
-    process_t * process   = hal_remote_lpt( XPTR( thread_cxy , &thread_ptr->process ) );
-    uint32_t    pid       = hal_remote_l32( XPTR( thread_cxy , &process->pid ) );
-    printk("\n[%s] thread[%x,%x] UNBLOCK thread[%x,%x] / rwlock %s [%x,%x]\n",
-    __FUNCTION__, this->process->pid, this->trdid, pid, trdid, 
-    lock_type_str[lock_type], lock_cxy, lock_ptr );
-}
-#endif
-
-        }
-    }
-
-    // release busylock 
-    remote_busylock_release( busylock_xp );
-
-}  // end remote_rwlock_rd_release()
-
-///////////////////////////////////////////////
-void remote_rwlock_wr_release( xptr_t lock_xp )
-{ 
-    // memory barrier before lock release
-    hal_fence();
-
-    // get cluster and local pointer on remote_rwlock
-    remote_rwlock_t * lock_ptr = GET_PTR( lock_xp );
-    cxy_t             lock_cxy = GET_CXY( lock_xp );
-
-    // build useful extended pointers
-    xptr_t busylock_xp = XPTR( lock_cxy , &lock_ptr->lock );
-    xptr_t taken_xp    = XPTR( lock_cxy , &lock_ptr->taken );
-    xptr_t rd_root_xp  = XPTR( lock_cxy , &lock_ptr->rd_xroot );
-    xptr_t wr_root_xp  = XPTR( lock_cxy , &lock_ptr->wr_xroot );
-
-    // get busylock
-    remote_busylock_acquire( busylock_xp );
-
-    // release rwlock
-    hal_remote_s32( taken_xp , 0 );
-
-#if DEBUG_RWLOCK_TYPE
-thread_t * this      = CURRENT_THREAD;
-uint32_t   lock_type = hal_remote_l32( XPTR( lock_cxy , &lock_ptr->lock.type ) );
-bool_t     cond      = (type == DEBUG_RWLOCK_TYPE) &&
-                       (((lock_cxy == (cxt_t)DEBUG_RWLOCK_CXY) &&
-                         (lock_ptr == (remote_queuelock_t*)DEBUG_RWLOCK_PTR)) ||
-                        ((DEBUG_RWLOCK_CXY == 0) &&
-                         (DEBUG_RWLOCK_PTR == 0)));
-xptr_t     count_xp  = XPTR( lock_cxy , &lock_ptr->count );
-#endif
-
-#if DEBUG_RWLOCK_TYPE
-if( cond )
-printk("\n[%s] thread[%x,%x] WRITE RELEASE %s [%x,%x]\n"
-"     taken %d / count %d / wr_empty %d / rd_empty %d\n",
-__FUNCTION__, this->process->pid, this->trdid,
-lock_type_str[lock_type], lock_cxy, lock_ptr,
-hal_remote_l32( taken_xp ), hal_remote_l32( count_xp ),
-xlist_is_empty( wr_root_xp ), xlist_is_empty( rd_root_xp ) );
-#endif
-
-    // unblock first waiting writer thread if writers waiting queue non empty
-    if( xlist_is_empty( wr_root_xp ) == false )
-    {
-        // get first writer thread
-        xptr_t      thread_xp  = XLIST_FIRST( wr_root_xp , thread_t, wait_xlist );
-        cxy_t       thread_cxy = GET_CXY( thread_xp ); 
-        thread_t *  thread_ptr = GET_PTR( thread_xp ); 
-
-        // remove this waiting thread from waiting list
-        xlist_unlink( XPTR( thread_cxy , &thread_ptr->wait_xlist ) );
-
-        // unblock this waiting thread
-        thread_unblock( thread_xp , THREAD_BLOCKED_LOCK );
-
-#if DEBUG_RWLOCK_TYPE
-if( cond )
-{
-    trdid_t     trdid     = hal_remote_l32( XPTR( thread_cxy , &thread_ptr->trdid ) );
-    process_t * process   = hal_remote_lpt( XPTR( thread_cxy , &thread_ptr->process ) );
-    uint32_t    pid       = hal_remote_l32( XPTR( thread_cxy , &process->pid ) );
-    printk("\n[%s] thread[%x,%x] UNBLOCK thread[%x,%x] / rwlock %s [%x,%x]\n",
-    __FUNCTION__, this->process->pid, this->trdid, pid, trdid, 
-    lock_type_str[lock_type], lock_cxy, lock_ptr );
-}
-#endif
-
-    }
-
-    // check readers waiting queue and unblock all if writers waiting queue empty
-    else 
-    {
-        while( xlist_is_empty( rd_root_xp ) == false )
-        {
-            // get first writer thread
-            xptr_t      thread_xp  = XLIST_FIRST( rd_root_xp , thread_t, wait_xlist );
-            cxy_t       thread_cxy = GET_CXY( thread_xp ); 
-            thread_t *  thread_ptr = GET_PTR( thread_xp ); 
-
-            // remove this waiting thread from waiting list
-            xlist_unlink( XPTR( thread_cxy , &thread_ptr->wait_xlist ) );
-
-            // unblock this waiting thread
-            thread_unblock( thread_xp , THREAD_BLOCKED_LOCK );
-
-#if DEBUG_RWLOCK_TYPE
-if( cond )
-{
-    trdid_t     trdid     = hal_remote_l32( XPTR( thread_cxy , &thread_ptr->trdid ) );
-    process_t * process   = hal_remote_lpt( XPTR( thread_cxy , &thread_ptr->process ) );
-    uint32_t    pid       = hal_remote_l32( XPTR( thread_cxy , &process->pid ) );
-    printk("\n[%s] thread[%x,%x] UNBLOCK thread[%x,%x] / rwlock %s [%x,%x]\n",
-    __FUNCTION__, this->process->pid, this->trdid, pid, trdid, 
-    lock_type_str[lock_type], lock_cxy, lock_ptr );
-}
-#endif
-
-        }
-    }
-
-    // release busylock 
-    remote_busylock_release( busylock_xp );
-
-}  // end remote_rwlock_wr_release()
-
-
-
+	uint32_t            mode;
+
+    // get cluster and local pointer on remote_rwlock
+    remote_rwlock_t * lock_ptr = (remote_rwlock_t *)GET_PTR( lock_xp );
+    cxy_t             lock_cxy = GET_CXY( lock_xp );
+
+    // get cluster and local pointer on local thread
+    cxy_t               thread_cxy = local_cxy;
+    thread_t          * thread_ptr = CURRENT_THREAD;
+
+    // compute extended pointers on lock->ticket, lock->owner and thread->remote_locks
+    xptr_t              current_xp = XPTR( lock_cxy   , &lock_ptr->ticket );
+    xptr_t              owner_xp   = XPTR( lock_cxy   , &lock_ptr->owner );
+    xptr_t              locks_xp   = XPTR( thread_cxy , &thread_ptr->remote_locks );
+
+    // disable interrupts
+	hal_disable_irq( &mode );
+  
+    // unregister owner thread, and release lock
+    hal_remote_swd( owner_xp , XPTR_NULL );
+    hal_remote_atomic_add( current_xp , 1 );
+	hal_remote_atomic_add( locks_xp , -1 );
+
+    // enable interrupts
+	hal_restore_irq( mode );
+
+}  // end remote_rwlock_wr_unlock()
+
+
